/***************************************************************************
 *                                                                         *
 *  MAXIMUS-CBCS Source Code, Version 1.02                                 *
 *  Copyright 1989, 1990 by Scott J. Dudley.  All rights reserved.         *
 *                                                                         *
 *  Routine to read *.MNU.  (Overlaid)                                     *
 *                                                                         *
 *  For complete details of the licensing restrictions, please refer to    *
 *  the licence agreement, which is published in its entirety in MAX.C     *
 *  and LICENCE.MAX.                                                       *
 *                                                                         *
 *  USE OF THIS FILE IS SUBJECT TO THE RESTRICTIONS CONTAINED IN THE       *
 *  MAXIMUS-CBCS LICENSING AGREEMENT.  IF YOU DO NOT FIND THE TEXT OF THIS *
 *  AGREEMENT IN ANY OF THE  AFOREMENTIONED FILES, OR IF YOU DO NOT HAVE   *
 *  THESE FILES, YOU SHOULD IMMEDIATELY CONTACT THE AUTHOR AT ONE OF THE   *
 *  ADDRESSES LISTED BELOW.  IN NO EVENT SHOULD YOU PROCEED TO USE THIS    *
 *  FILE WITHOUT HAVING ACCEPTED THE TERMS OF THE MAXIMUS-CBCS LICENSING   *
 *  AGREEMENT, OR SUCH OTHER AGREEMENT AS YOU ARE ABLE TO REACH WITH THE   *
 *  AUTHOR.                                                                *
 *                                                                         *
 *  You can contact the author at one of the address listed below:         *
 *                                                                         *
 *  Scott Dudley           FidoNet  1:249/106                              *
 *  777 Downing St.        IMEXnet  89:483/202                             *
 *  Kingston, Ont.         Internet f106.n249.z1.fidonet.org               *
 *  Canada - K7M 5N3       BBS      (613) 389-8315 - HST/14.4K, 24hrs      *
 *                                                                         *
 ***************************************************************************/

#include <stdio.h>
#include <string.h>
#include <fcntl.h>
#include <stdlib.h>
#include "prog.h"
#include "max.h"

static FILE *menufile;

static void near pascal RdInt(void *a)
{
  fread((char *)a,sizeof(int),1,menufile);
}


void pascal Read_Menu(struct _menu *menu,char *mname,char *iread)
{
  int menu_items,
      x,y;

  char temp[PATHLEN];

  if (menu->num_options)
    Free_Menu(menu);

#ifdef DMALLOC
  ptab();
#endif

  menu_lines=0;
  menu_items=1;
  
  if (iread)
    *iread='\0';

  sprintf(temp,"%s%s.Mnu",menupath,mname);

  Initialize_Menu(menu);

  if ((menufile=shfopen(temp,fopen_readb,O_RDONLY | O_BINARY))==NULL)
  {
    logit(cantopen_crit,temp);
    quit(2);
  }
  else
  {
    RdInt(&menu->header);
    RdInt(&menu->num_options);
    RdInt(&menu->menu_length);
    RdInt(&menu->hot_colour);
    RdInt(&menu->title_len);

    if ((x=menu->title_len) != 0)
    {
      if ((menu->title=(char *)malloc(x+1)) != NULL)
      {
        fread(menu->title,x,1,menufile);
        menu->title[x]='\0';
      }
      else
      {
        menu->title=NULL;
        fseek(menufile,(long)x,SEEK_CUR);
      }
    }

    fread((char *)&menu->dspfile_len,sizeof(int),1,menufile);

    if ((x=menu->dspfile_len) != 0)
    {
      if ((menu->dspfile=(char *)malloc(x+1)) != NULL)
      {
        fread(menu->dspfile,x,1,menufile);
        menu->dspfile[x]='\0';
      }
      else
      {
        menu->dspfile=NULL;
        fseek(menufile,(long)x,SEEK_CUR);
      }
    }

    fread((char *)&menu->headfile_len,sizeof(int),1,menufile);

    if ((x=menu->headfile_len) != 0)
    {
      if ((menu->headfile=(char *)malloc(x+1)) != NULL)
      {
        fread(menu->headfile,x,1,menufile);
        menu->headfile[x]='\0';
      }
      else
      {
        menu->headfile=NULL;
        fseek(menufile,(long)x,SEEK_CUR);
      }
    }

    for (x=0;x < menu->num_options;x++)
    {
      if ((menu->options[x]=(struct _opt *)malloc(sizeof(struct _opt)))==NULL)
      {
        logit(s(log_no_menu_mem));
        quit(2);
      }

      /* Initialize the menu options */

      menu->options[x]->type=nothing;
      menu->options[x]->arglen=0;
      menu->arg[x]=NULL;
      menu->options[x]->keypoke=NULL;

      fread((char *)menu->options[x],1,sizeof(struct _opt),menufile);
      menu->options[x]->name[18]='\0';

      if (menu->options[x]->arglen)
      {
        if ((menu->arg[x]=(char *)malloc(menu->options[x]->arglen+1))==NULL)
          fseek(menufile,(long)menu->options[x]->arglen,SEEK_CUR);
        else
        {
          fread(menu->arg[x],menu->options[x]->arglen,1,menufile);
          menu->arg[x][menu->options[x]->arglen]='\0';
        }
      }

      if (menu->options[x]->kp_len)
      {
        if ((menu->options[x]->keypoke=(byte far *)malloc(menu->options[x]->kp_len+1))==NULL)
          fseek(menufile,(long)menu->options[x]->kp_len,SEEK_CUR);
        else
        {
          fread((byte *)(unsigned long)menu->options[x]->keypoke,menu->options[x]->kp_len,1,menufile);
          menu->options[x]->keypoke[menu->options[x]->kp_len]='\0';
        }
      }

      if (menu->options[x]->type && *menu->options[x]->name)
      {
        if (iread && menu->options[x]->type==read_individual &&
            OptionOkay(menu->options[x],1,NULL))
        {
          if ((y=strlen(iread)) < IREADLEN-1)
          {
            iread[y]=*menu->options[x]->name;
            iread[++y]='\0';
          }
        }


        if (OptionOkay(menu->options[x],0,NULL))
        {
          if (usr.help==NOVICE)
          {
            if (menu_items++==1)
              menu_lines++;
          }

          if (menu_items >= (usr.width+1)/20)
            menu_items=1;
        }
      }
    }

    if (menu->dspfile)
      menu_lines=menu->menu_length;

    fclose(menufile);
  }
  
  if (iread)
    strupr(iread);
}


